package com.hfkj.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class BsOrderChildExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public BsOrderChildExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrderNoIsNull() {
            addCriterion("order_no is null");
            return (Criteria) this;
        }

        public Criteria andOrderNoIsNotNull() {
            addCriterion("order_no is not null");
            return (Criteria) this;
        }

        public Criteria andOrderNoEqualTo(String value) {
            addCriterion("order_no =", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotEqualTo(String value) {
            addCriterion("order_no <>", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoGreaterThan(String value) {
            addCriterion("order_no >", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoGreaterThanOrEqualTo(String value) {
            addCriterion("order_no >=", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLessThan(String value) {
            addCriterion("order_no <", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLessThanOrEqualTo(String value) {
            addCriterion("order_no <=", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLike(String value) {
            addCriterion("order_no like", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotLike(String value) {
            addCriterion("order_no not like", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoIn(List<String> values) {
            addCriterion("order_no in", values, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotIn(List<String> values) {
            addCriterion("order_no not in", values, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoBetween(String value1, String value2) {
            addCriterion("order_no between", value1, value2, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotBetween(String value1, String value2) {
            addCriterion("order_no not between", value1, value2, "orderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoIsNull() {
            addCriterion("child_order_no is null");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoIsNotNull() {
            addCriterion("child_order_no is not null");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoEqualTo(String value) {
            addCriterion("child_order_no =", value, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoNotEqualTo(String value) {
            addCriterion("child_order_no <>", value, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoGreaterThan(String value) {
            addCriterion("child_order_no >", value, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoGreaterThanOrEqualTo(String value) {
            addCriterion("child_order_no >=", value, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoLessThan(String value) {
            addCriterion("child_order_no <", value, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoLessThanOrEqualTo(String value) {
            addCriterion("child_order_no <=", value, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoLike(String value) {
            addCriterion("child_order_no like", value, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoNotLike(String value) {
            addCriterion("child_order_no not like", value, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoIn(List<String> values) {
            addCriterion("child_order_no in", values, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoNotIn(List<String> values) {
            addCriterion("child_order_no not in", values, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoBetween(String value1, String value2) {
            addCriterion("child_order_no between", value1, value2, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderNoNotBetween(String value1, String value2) {
            addCriterion("child_order_no not between", value1, value2, "childOrderNo");
            return (Criteria) this;
        }

        public Criteria andMerIdIsNull() {
            addCriterion("mer_id is null");
            return (Criteria) this;
        }

        public Criteria andMerIdIsNotNull() {
            addCriterion("mer_id is not null");
            return (Criteria) this;
        }

        public Criteria andMerIdEqualTo(Long value) {
            addCriterion("mer_id =", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdNotEqualTo(Long value) {
            addCriterion("mer_id <>", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdGreaterThan(Long value) {
            addCriterion("mer_id >", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdGreaterThanOrEqualTo(Long value) {
            addCriterion("mer_id >=", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdLessThan(Long value) {
            addCriterion("mer_id <", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdLessThanOrEqualTo(Long value) {
            addCriterion("mer_id <=", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdIn(List<Long> values) {
            addCriterion("mer_id in", values, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdNotIn(List<Long> values) {
            addCriterion("mer_id not in", values, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdBetween(Long value1, Long value2) {
            addCriterion("mer_id between", value1, value2, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdNotBetween(Long value1, Long value2) {
            addCriterion("mer_id not between", value1, value2, "merId");
            return (Criteria) this;
        }

        public Criteria andProductTypeIsNull() {
            addCriterion("product_type is null");
            return (Criteria) this;
        }

        public Criteria andProductTypeIsNotNull() {
            addCriterion("product_type is not null");
            return (Criteria) this;
        }

        public Criteria andProductTypeEqualTo(Integer value) {
            addCriterion("product_type =", value, "productType");
            return (Criteria) this;
        }

        public Criteria andProductTypeNotEqualTo(Integer value) {
            addCriterion("product_type <>", value, "productType");
            return (Criteria) this;
        }

        public Criteria andProductTypeGreaterThan(Integer value) {
            addCriterion("product_type >", value, "productType");
            return (Criteria) this;
        }

        public Criteria andProductTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("product_type >=", value, "productType");
            return (Criteria) this;
        }

        public Criteria andProductTypeLessThan(Integer value) {
            addCriterion("product_type <", value, "productType");
            return (Criteria) this;
        }

        public Criteria andProductTypeLessThanOrEqualTo(Integer value) {
            addCriterion("product_type <=", value, "productType");
            return (Criteria) this;
        }

        public Criteria andProductTypeIn(List<Integer> values) {
            addCriterion("product_type in", values, "productType");
            return (Criteria) this;
        }

        public Criteria andProductTypeNotIn(List<Integer> values) {
            addCriterion("product_type not in", values, "productType");
            return (Criteria) this;
        }

        public Criteria andProductTypeBetween(Integer value1, Integer value2) {
            addCriterion("product_type between", value1, value2, "productType");
            return (Criteria) this;
        }

        public Criteria andProductTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("product_type not between", value1, value2, "productType");
            return (Criteria) this;
        }

        public Criteria andProductIdIsNull() {
            addCriterion("product_id is null");
            return (Criteria) this;
        }

        public Criteria andProductIdIsNotNull() {
            addCriterion("product_id is not null");
            return (Criteria) this;
        }

        public Criteria andProductIdEqualTo(Long value) {
            addCriterion("product_id =", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdNotEqualTo(Long value) {
            addCriterion("product_id <>", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdGreaterThan(Long value) {
            addCriterion("product_id >", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdGreaterThanOrEqualTo(Long value) {
            addCriterion("product_id >=", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdLessThan(Long value) {
            addCriterion("product_id <", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdLessThanOrEqualTo(Long value) {
            addCriterion("product_id <=", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdIn(List<Long> values) {
            addCriterion("product_id in", values, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdNotIn(List<Long> values) {
            addCriterion("product_id not in", values, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdBetween(Long value1, Long value2) {
            addCriterion("product_id between", value1, value2, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdNotBetween(Long value1, Long value2) {
            addCriterion("product_id not between", value1, value2, "productId");
            return (Criteria) this;
        }

        public Criteria andProductNameIsNull() {
            addCriterion("product_name is null");
            return (Criteria) this;
        }

        public Criteria andProductNameIsNotNull() {
            addCriterion("product_name is not null");
            return (Criteria) this;
        }

        public Criteria andProductNameEqualTo(String value) {
            addCriterion("product_name =", value, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameNotEqualTo(String value) {
            addCriterion("product_name <>", value, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameGreaterThan(String value) {
            addCriterion("product_name >", value, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameGreaterThanOrEqualTo(String value) {
            addCriterion("product_name >=", value, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameLessThan(String value) {
            addCriterion("product_name <", value, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameLessThanOrEqualTo(String value) {
            addCriterion("product_name <=", value, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameLike(String value) {
            addCriterion("product_name like", value, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameNotLike(String value) {
            addCriterion("product_name not like", value, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameIn(List<String> values) {
            addCriterion("product_name in", values, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameNotIn(List<String> values) {
            addCriterion("product_name not in", values, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameBetween(String value1, String value2) {
            addCriterion("product_name between", value1, value2, "productName");
            return (Criteria) this;
        }

        public Criteria andProductNameNotBetween(String value1, String value2) {
            addCriterion("product_name not between", value1, value2, "productName");
            return (Criteria) this;
        }

        public Criteria andProductImgIsNull() {
            addCriterion("product_img is null");
            return (Criteria) this;
        }

        public Criteria andProductImgIsNotNull() {
            addCriterion("product_img is not null");
            return (Criteria) this;
        }

        public Criteria andProductImgEqualTo(String value) {
            addCriterion("product_img =", value, "productImg");
            return (Criteria) this;
        }

        public Criteria andProductImgNotEqualTo(String value) {
            addCriterion("product_img <>", value, "productImg");
            return (Criteria) this;
        }

        public Criteria andProductImgGreaterThan(String value) {
            addCriterion("product_img >", value, "productImg");
            return (Criteria) this;
        }

        public Criteria andProductImgGreaterThanOrEqualTo(String value) {
            addCriterion("product_img >=", value, "productImg");
            return (Criteria) this;
        }

        public Criteria andProductImgLessThan(String value) {
            addCriterion("product_img <", value, "productImg");
            return (Criteria) this;
        }

        public Criteria andProductImgLessThanOrEqualTo(String value) {
            addCriterion("product_img <=", value, "productImg");
            return (Criteria) this;
        }

        public Criteria andProductImgLike(String value) {
            addCriterion("product_img like", value, "productImg");
            return (Criteria) this;
        }

        public Criteria andProductImgNotLike(String value) {
            addCriterion("product_img not like", value, "productImg");
            return (Criteria) this;
        }

        public Criteria andProductImgIn(List<String> values) {
            addCriterion("product_img in", values, "productImg");
            return (Criteria) this;
        }

        public Criteria andProductImgNotIn(List<String> values) {
            addCriterion("product_img not in", values, "productImg");
            return (Criteria) this;
        }

        public Criteria andProductImgBetween(String value1, String value2) {
            addCriterion("product_img between", value1, value2, "productImg");
            return (Criteria) this;
        }

        public Criteria andProductImgNotBetween(String value1, String value2) {
            addCriterion("product_img not between", value1, value2, "productImg");
            return (Criteria) this;
        }

        public Criteria andProductSpecIdIsNull() {
            addCriterion("product_spec_id is null");
            return (Criteria) this;
        }

        public Criteria andProductSpecIdIsNotNull() {
            addCriterion("product_spec_id is not null");
            return (Criteria) this;
        }

        public Criteria andProductSpecIdEqualTo(Long value) {
            addCriterion("product_spec_id =", value, "productSpecId");
            return (Criteria) this;
        }

        public Criteria andProductSpecIdNotEqualTo(Long value) {
            addCriterion("product_spec_id <>", value, "productSpecId");
            return (Criteria) this;
        }

        public Criteria andProductSpecIdGreaterThan(Long value) {
            addCriterion("product_spec_id >", value, "productSpecId");
            return (Criteria) this;
        }

        public Criteria andProductSpecIdGreaterThanOrEqualTo(Long value) {
            addCriterion("product_spec_id >=", value, "productSpecId");
            return (Criteria) this;
        }

        public Criteria andProductSpecIdLessThan(Long value) {
            addCriterion("product_spec_id <", value, "productSpecId");
            return (Criteria) this;
        }

        public Criteria andProductSpecIdLessThanOrEqualTo(Long value) {
            addCriterion("product_spec_id <=", value, "productSpecId");
            return (Criteria) this;
        }

        public Criteria andProductSpecIdIn(List<Long> values) {
            addCriterion("product_spec_id in", values, "productSpecId");
            return (Criteria) this;
        }

        public Criteria andProductSpecIdNotIn(List<Long> values) {
            addCriterion("product_spec_id not in", values, "productSpecId");
            return (Criteria) this;
        }

        public Criteria andProductSpecIdBetween(Long value1, Long value2) {
            addCriterion("product_spec_id between", value1, value2, "productSpecId");
            return (Criteria) this;
        }

        public Criteria andProductSpecIdNotBetween(Long value1, Long value2) {
            addCriterion("product_spec_id not between", value1, value2, "productSpecId");
            return (Criteria) this;
        }

        public Criteria andProductSpecNameIsNull() {
            addCriterion("product_spec_name is null");
            return (Criteria) this;
        }

        public Criteria andProductSpecNameIsNotNull() {
            addCriterion("product_spec_name is not null");
            return (Criteria) this;
        }

        public Criteria andProductSpecNameEqualTo(String value) {
            addCriterion("product_spec_name =", value, "productSpecName");
            return (Criteria) this;
        }

        public Criteria andProductSpecNameNotEqualTo(String value) {
            addCriterion("product_spec_name <>", value, "productSpecName");
            return (Criteria) this;
        }

        public Criteria andProductSpecNameGreaterThan(String value) {
            addCriterion("product_spec_name >", value, "productSpecName");
            return (Criteria) this;
        }

        public Criteria andProductSpecNameGreaterThanOrEqualTo(String value) {
            addCriterion("product_spec_name >=", value, "productSpecName");
            return (Criteria) this;
        }

        public Criteria andProductSpecNameLessThan(String value) {
            addCriterion("product_spec_name <", value, "productSpecName");
            return (Criteria) this;
        }

        public Criteria andProductSpecNameLessThanOrEqualTo(String value) {
            addCriterion("product_spec_name <=", value, "productSpecName");
            return (Criteria) this;
        }

        public Criteria andProductSpecNameLike(String value) {
            addCriterion("product_spec_name like", value, "productSpecName");
            return (Criteria) this;
        }

        public Criteria andProductSpecNameNotLike(String value) {
            addCriterion("product_spec_name not like", value, "productSpecName");
            return (Criteria) this;
        }

        public Criteria andProductSpecNameIn(List<String> values) {
            addCriterion("product_spec_name in", values, "productSpecName");
            return (Criteria) this;
        }

        public Criteria andProductSpecNameNotIn(List<String> values) {
            addCriterion("product_spec_name not in", values, "productSpecName");
            return (Criteria) this;
        }

        public Criteria andProductSpecNameBetween(String value1, String value2) {
            addCriterion("product_spec_name between", value1, value2, "productSpecName");
            return (Criteria) this;
        }

        public Criteria andProductSpecNameNotBetween(String value1, String value2) {
            addCriterion("product_spec_name not between", value1, value2, "productSpecName");
            return (Criteria) this;
        }

        public Criteria andProductPriceIsNull() {
            addCriterion("product_price is null");
            return (Criteria) this;
        }

        public Criteria andProductPriceIsNotNull() {
            addCriterion("product_price is not null");
            return (Criteria) this;
        }

        public Criteria andProductPriceEqualTo(BigDecimal value) {
            addCriterion("product_price =", value, "productPrice");
            return (Criteria) this;
        }

        public Criteria andProductPriceNotEqualTo(BigDecimal value) {
            addCriterion("product_price <>", value, "productPrice");
            return (Criteria) this;
        }

        public Criteria andProductPriceGreaterThan(BigDecimal value) {
            addCriterion("product_price >", value, "productPrice");
            return (Criteria) this;
        }

        public Criteria andProductPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("product_price >=", value, "productPrice");
            return (Criteria) this;
        }

        public Criteria andProductPriceLessThan(BigDecimal value) {
            addCriterion("product_price <", value, "productPrice");
            return (Criteria) this;
        }

        public Criteria andProductPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("product_price <=", value, "productPrice");
            return (Criteria) this;
        }

        public Criteria andProductPriceIn(List<BigDecimal> values) {
            addCriterion("product_price in", values, "productPrice");
            return (Criteria) this;
        }

        public Criteria andProductPriceNotIn(List<BigDecimal> values) {
            addCriterion("product_price not in", values, "productPrice");
            return (Criteria) this;
        }

        public Criteria andProductPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("product_price between", value1, value2, "productPrice");
            return (Criteria) this;
        }

        public Criteria andProductPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("product_price not between", value1, value2, "productPrice");
            return (Criteria) this;
        }

        public Criteria andProductCountIsNull() {
            addCriterion("product_count is null");
            return (Criteria) this;
        }

        public Criteria andProductCountIsNotNull() {
            addCriterion("product_count is not null");
            return (Criteria) this;
        }

        public Criteria andProductCountEqualTo(Integer value) {
            addCriterion("product_count =", value, "productCount");
            return (Criteria) this;
        }

        public Criteria andProductCountNotEqualTo(Integer value) {
            addCriterion("product_count <>", value, "productCount");
            return (Criteria) this;
        }

        public Criteria andProductCountGreaterThan(Integer value) {
            addCriterion("product_count >", value, "productCount");
            return (Criteria) this;
        }

        public Criteria andProductCountGreaterThanOrEqualTo(Integer value) {
            addCriterion("product_count >=", value, "productCount");
            return (Criteria) this;
        }

        public Criteria andProductCountLessThan(Integer value) {
            addCriterion("product_count <", value, "productCount");
            return (Criteria) this;
        }

        public Criteria andProductCountLessThanOrEqualTo(Integer value) {
            addCriterion("product_count <=", value, "productCount");
            return (Criteria) this;
        }

        public Criteria andProductCountIn(List<Integer> values) {
            addCriterion("product_count in", values, "productCount");
            return (Criteria) this;
        }

        public Criteria andProductCountNotIn(List<Integer> values) {
            addCriterion("product_count not in", values, "productCount");
            return (Criteria) this;
        }

        public Criteria andProductCountBetween(Integer value1, Integer value2) {
            addCriterion("product_count between", value1, value2, "productCount");
            return (Criteria) this;
        }

        public Criteria andProductCountNotBetween(Integer value1, Integer value2) {
            addCriterion("product_count not between", value1, value2, "productCount");
            return (Criteria) this;
        }

        public Criteria andProductTotalPriceIsNull() {
            addCriterion("product_total_price is null");
            return (Criteria) this;
        }

        public Criteria andProductTotalPriceIsNotNull() {
            addCriterion("product_total_price is not null");
            return (Criteria) this;
        }

        public Criteria andProductTotalPriceEqualTo(BigDecimal value) {
            addCriterion("product_total_price =", value, "productTotalPrice");
            return (Criteria) this;
        }

        public Criteria andProductTotalPriceNotEqualTo(BigDecimal value) {
            addCriterion("product_total_price <>", value, "productTotalPrice");
            return (Criteria) this;
        }

        public Criteria andProductTotalPriceGreaterThan(BigDecimal value) {
            addCriterion("product_total_price >", value, "productTotalPrice");
            return (Criteria) this;
        }

        public Criteria andProductTotalPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("product_total_price >=", value, "productTotalPrice");
            return (Criteria) this;
        }

        public Criteria andProductTotalPriceLessThan(BigDecimal value) {
            addCriterion("product_total_price <", value, "productTotalPrice");
            return (Criteria) this;
        }

        public Criteria andProductTotalPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("product_total_price <=", value, "productTotalPrice");
            return (Criteria) this;
        }

        public Criteria andProductTotalPriceIn(List<BigDecimal> values) {
            addCriterion("product_total_price in", values, "productTotalPrice");
            return (Criteria) this;
        }

        public Criteria andProductTotalPriceNotIn(List<BigDecimal> values) {
            addCriterion("product_total_price not in", values, "productTotalPrice");
            return (Criteria) this;
        }

        public Criteria andProductTotalPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("product_total_price between", value1, value2, "productTotalPrice");
            return (Criteria) this;
        }

        public Criteria andProductTotalPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("product_total_price not between", value1, value2, "productTotalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceIsNull() {
            addCriterion("total_deduction_price is null");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceIsNotNull() {
            addCriterion("total_deduction_price is not null");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceEqualTo(BigDecimal value) {
            addCriterion("total_deduction_price =", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceNotEqualTo(BigDecimal value) {
            addCriterion("total_deduction_price <>", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceGreaterThan(BigDecimal value) {
            addCriterion("total_deduction_price >", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("total_deduction_price >=", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceLessThan(BigDecimal value) {
            addCriterion("total_deduction_price <", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("total_deduction_price <=", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceIn(List<BigDecimal> values) {
            addCriterion("total_deduction_price in", values, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceNotIn(List<BigDecimal> values) {
            addCriterion("total_deduction_price not in", values, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_deduction_price between", value1, value2, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_deduction_price not between", value1, value2, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceIsNull() {
            addCriterion("coupon_discount_price is null");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceIsNotNull() {
            addCriterion("coupon_discount_price is not null");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceEqualTo(BigDecimal value) {
            addCriterion("coupon_discount_price =", value, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceNotEqualTo(BigDecimal value) {
            addCriterion("coupon_discount_price <>", value, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceGreaterThan(BigDecimal value) {
            addCriterion("coupon_discount_price >", value, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("coupon_discount_price >=", value, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceLessThan(BigDecimal value) {
            addCriterion("coupon_discount_price <", value, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("coupon_discount_price <=", value, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceIn(List<BigDecimal> values) {
            addCriterion("coupon_discount_price in", values, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceNotIn(List<BigDecimal> values) {
            addCriterion("coupon_discount_price not in", values, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("coupon_discount_price between", value1, value2, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("coupon_discount_price not between", value1, value2, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceIsNull() {
            addCriterion("integral_discount_price is null");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceIsNotNull() {
            addCriterion("integral_discount_price is not null");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceEqualTo(Long value) {
            addCriterion("integral_discount_price =", value, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceNotEqualTo(Long value) {
            addCriterion("integral_discount_price <>", value, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceGreaterThan(Long value) {
            addCriterion("integral_discount_price >", value, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceGreaterThanOrEqualTo(Long value) {
            addCriterion("integral_discount_price >=", value, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceLessThan(Long value) {
            addCriterion("integral_discount_price <", value, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceLessThanOrEqualTo(Long value) {
            addCriterion("integral_discount_price <=", value, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceIn(List<Long> values) {
            addCriterion("integral_discount_price in", values, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceNotIn(List<Long> values) {
            addCriterion("integral_discount_price not in", values, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceBetween(Long value1, Long value2) {
            addCriterion("integral_discount_price between", value1, value2, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceNotBetween(Long value1, Long value2) {
            addCriterion("integral_discount_price not between", value1, value2, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andProductActualPriceIsNull() {
            addCriterion("product_actual_price is null");
            return (Criteria) this;
        }

        public Criteria andProductActualPriceIsNotNull() {
            addCriterion("product_actual_price is not null");
            return (Criteria) this;
        }

        public Criteria andProductActualPriceEqualTo(BigDecimal value) {
            addCriterion("product_actual_price =", value, "productActualPrice");
            return (Criteria) this;
        }

        public Criteria andProductActualPriceNotEqualTo(BigDecimal value) {
            addCriterion("product_actual_price <>", value, "productActualPrice");
            return (Criteria) this;
        }

        public Criteria andProductActualPriceGreaterThan(BigDecimal value) {
            addCriterion("product_actual_price >", value, "productActualPrice");
            return (Criteria) this;
        }

        public Criteria andProductActualPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("product_actual_price >=", value, "productActualPrice");
            return (Criteria) this;
        }

        public Criteria andProductActualPriceLessThan(BigDecimal value) {
            addCriterion("product_actual_price <", value, "productActualPrice");
            return (Criteria) this;
        }

        public Criteria andProductActualPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("product_actual_price <=", value, "productActualPrice");
            return (Criteria) this;
        }

        public Criteria andProductActualPriceIn(List<BigDecimal> values) {
            addCriterion("product_actual_price in", values, "productActualPrice");
            return (Criteria) this;
        }

        public Criteria andProductActualPriceNotIn(List<BigDecimal> values) {
            addCriterion("product_actual_price not in", values, "productActualPrice");
            return (Criteria) this;
        }

        public Criteria andProductActualPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("product_actual_price between", value1, value2, "productActualPrice");
            return (Criteria) this;
        }

        public Criteria andProductActualPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("product_actual_price not between", value1, value2, "productActualPrice");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundCountIsNull() {
            addCriterion("surplus_refund_count is null");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundCountIsNotNull() {
            addCriterion("surplus_refund_count is not null");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundCountEqualTo(Integer value) {
            addCriterion("surplus_refund_count =", value, "surplusRefundCount");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundCountNotEqualTo(Integer value) {
            addCriterion("surplus_refund_count <>", value, "surplusRefundCount");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundCountGreaterThan(Integer value) {
            addCriterion("surplus_refund_count >", value, "surplusRefundCount");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundCountGreaterThanOrEqualTo(Integer value) {
            addCriterion("surplus_refund_count >=", value, "surplusRefundCount");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundCountLessThan(Integer value) {
            addCriterion("surplus_refund_count <", value, "surplusRefundCount");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundCountLessThanOrEqualTo(Integer value) {
            addCriterion("surplus_refund_count <=", value, "surplusRefundCount");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundCountIn(List<Integer> values) {
            addCriterion("surplus_refund_count in", values, "surplusRefundCount");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundCountNotIn(List<Integer> values) {
            addCriterion("surplus_refund_count not in", values, "surplusRefundCount");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundCountBetween(Integer value1, Integer value2) {
            addCriterion("surplus_refund_count between", value1, value2, "surplusRefundCount");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundCountNotBetween(Integer value1, Integer value2) {
            addCriterion("surplus_refund_count not between", value1, value2, "surplusRefundCount");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceIsNull() {
            addCriterion("surplus_refund_price is null");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceIsNotNull() {
            addCriterion("surplus_refund_price is not null");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceEqualTo(BigDecimal value) {
            addCriterion("surplus_refund_price =", value, "surplusRefundPrice");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceNotEqualTo(BigDecimal value) {
            addCriterion("surplus_refund_price <>", value, "surplusRefundPrice");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceGreaterThan(BigDecimal value) {
            addCriterion("surplus_refund_price >", value, "surplusRefundPrice");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("surplus_refund_price >=", value, "surplusRefundPrice");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceLessThan(BigDecimal value) {
            addCriterion("surplus_refund_price <", value, "surplusRefundPrice");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("surplus_refund_price <=", value, "surplusRefundPrice");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceIn(List<BigDecimal> values) {
            addCriterion("surplus_refund_price in", values, "surplusRefundPrice");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceNotIn(List<BigDecimal> values) {
            addCriterion("surplus_refund_price not in", values, "surplusRefundPrice");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("surplus_refund_price between", value1, value2, "surplusRefundPrice");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("surplus_refund_price not between", value1, value2, "surplusRefundPrice");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralIsNull() {
            addCriterion("surplus_refund_integral is null");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralIsNotNull() {
            addCriterion("surplus_refund_integral is not null");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralEqualTo(Long value) {
            addCriterion("surplus_refund_integral =", value, "surplusRefundIntegral");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralNotEqualTo(Long value) {
            addCriterion("surplus_refund_integral <>", value, "surplusRefundIntegral");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralGreaterThan(Long value) {
            addCriterion("surplus_refund_integral >", value, "surplusRefundIntegral");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralGreaterThanOrEqualTo(Long value) {
            addCriterion("surplus_refund_integral >=", value, "surplusRefundIntegral");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralLessThan(Long value) {
            addCriterion("surplus_refund_integral <", value, "surplusRefundIntegral");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralLessThanOrEqualTo(Long value) {
            addCriterion("surplus_refund_integral <=", value, "surplusRefundIntegral");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralIn(List<Long> values) {
            addCriterion("surplus_refund_integral in", values, "surplusRefundIntegral");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralNotIn(List<Long> values) {
            addCriterion("surplus_refund_integral not in", values, "surplusRefundIntegral");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralBetween(Long value1, Long value2) {
            addCriterion("surplus_refund_integral between", value1, value2, "surplusRefundIntegral");
            return (Criteria) this;
        }

        public Criteria andSurplusRefundIntegralNotBetween(Long value1, Long value2) {
            addCriterion("surplus_refund_integral not between", value1, value2, "surplusRefundIntegral");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andSettleAccountIsNull() {
            addCriterion("settle_account is null");
            return (Criteria) this;
        }

        public Criteria andSettleAccountIsNotNull() {
            addCriterion("settle_account is not null");
            return (Criteria) this;
        }

        public Criteria andSettleAccountEqualTo(String value) {
            addCriterion("settle_account =", value, "settleAccount");
            return (Criteria) this;
        }

        public Criteria andSettleAccountNotEqualTo(String value) {
            addCriterion("settle_account <>", value, "settleAccount");
            return (Criteria) this;
        }

        public Criteria andSettleAccountGreaterThan(String value) {
            addCriterion("settle_account >", value, "settleAccount");
            return (Criteria) this;
        }

        public Criteria andSettleAccountGreaterThanOrEqualTo(String value) {
            addCriterion("settle_account >=", value, "settleAccount");
            return (Criteria) this;
        }

        public Criteria andSettleAccountLessThan(String value) {
            addCriterion("settle_account <", value, "settleAccount");
            return (Criteria) this;
        }

        public Criteria andSettleAccountLessThanOrEqualTo(String value) {
            addCriterion("settle_account <=", value, "settleAccount");
            return (Criteria) this;
        }

        public Criteria andSettleAccountLike(String value) {
            addCriterion("settle_account like", value, "settleAccount");
            return (Criteria) this;
        }

        public Criteria andSettleAccountNotLike(String value) {
            addCriterion("settle_account not like", value, "settleAccount");
            return (Criteria) this;
        }

        public Criteria andSettleAccountIn(List<String> values) {
            addCriterion("settle_account in", values, "settleAccount");
            return (Criteria) this;
        }

        public Criteria andSettleAccountNotIn(List<String> values) {
            addCriterion("settle_account not in", values, "settleAccount");
            return (Criteria) this;
        }

        public Criteria andSettleAccountBetween(String value1, String value2) {
            addCriterion("settle_account between", value1, value2, "settleAccount");
            return (Criteria) this;
        }

        public Criteria andSettleAccountNotBetween(String value1, String value2) {
            addCriterion("settle_account not between", value1, value2, "settleAccount");
            return (Criteria) this;
        }

        public Criteria andSettleAccountKeyIsNull() {
            addCriterion("settle_account_key is null");
            return (Criteria) this;
        }

        public Criteria andSettleAccountKeyIsNotNull() {
            addCriterion("settle_account_key is not null");
            return (Criteria) this;
        }

        public Criteria andSettleAccountKeyEqualTo(String value) {
            addCriterion("settle_account_key =", value, "settleAccountKey");
            return (Criteria) this;
        }

        public Criteria andSettleAccountKeyNotEqualTo(String value) {
            addCriterion("settle_account_key <>", value, "settleAccountKey");
            return (Criteria) this;
        }

        public Criteria andSettleAccountKeyGreaterThan(String value) {
            addCriterion("settle_account_key >", value, "settleAccountKey");
            return (Criteria) this;
        }

        public Criteria andSettleAccountKeyGreaterThanOrEqualTo(String value) {
            addCriterion("settle_account_key >=", value, "settleAccountKey");
            return (Criteria) this;
        }

        public Criteria andSettleAccountKeyLessThan(String value) {
            addCriterion("settle_account_key <", value, "settleAccountKey");
            return (Criteria) this;
        }

        public Criteria andSettleAccountKeyLessThanOrEqualTo(String value) {
            addCriterion("settle_account_key <=", value, "settleAccountKey");
            return (Criteria) this;
        }

        public Criteria andSettleAccountKeyLike(String value) {
            addCriterion("settle_account_key like", value, "settleAccountKey");
            return (Criteria) this;
        }

        public Criteria andSettleAccountKeyNotLike(String value) {
            addCriterion("settle_account_key not like", value, "settleAccountKey");
            return (Criteria) this;
        }

        public Criteria andSettleAccountKeyIn(List<String> values) {
            addCriterion("settle_account_key in", values, "settleAccountKey");
            return (Criteria) this;
        }

        public Criteria andSettleAccountKeyNotIn(List<String> values) {
            addCriterion("settle_account_key not in", values, "settleAccountKey");
            return (Criteria) this;
        }

        public Criteria andSettleAccountKeyBetween(String value1, String value2) {
            addCriterion("settle_account_key between", value1, value2, "settleAccountKey");
            return (Criteria) this;
        }

        public Criteria andSettleAccountKeyNotBetween(String value1, String value2) {
            addCriterion("settle_account_key not between", value1, value2, "settleAccountKey");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeIsNull() {
            addCriterion("finish_time is null");
            return (Criteria) this;
        }

        public Criteria andFinishTimeIsNotNull() {
            addCriterion("finish_time is not null");
            return (Criteria) this;
        }

        public Criteria andFinishTimeEqualTo(Date value) {
            addCriterion("finish_time =", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeNotEqualTo(Date value) {
            addCriterion("finish_time <>", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeGreaterThan(Date value) {
            addCriterion("finish_time >", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("finish_time >=", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeLessThan(Date value) {
            addCriterion("finish_time <", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeLessThanOrEqualTo(Date value) {
            addCriterion("finish_time <=", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeIn(List<Date> values) {
            addCriterion("finish_time in", values, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeNotIn(List<Date> values) {
            addCriterion("finish_time not in", values, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeBetween(Date value1, Date value2) {
            addCriterion("finish_time between", value1, value2, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeNotBetween(Date value1, Date value2) {
            addCriterion("finish_time not between", value1, value2, "finishTime");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andChannelOrderNoIsNull() {
            addCriterion("channel_order_no is null");
            return (Criteria) this;
        }

        public Criteria andChannelOrderNoIsNotNull() {
            addCriterion("channel_order_no is not null");
            return (Criteria) this;
        }

        public Criteria andChannelOrderNoEqualTo(String value) {
            addCriterion("channel_order_no =", value, "channelOrderNo");
            return (Criteria) this;
        }

        public Criteria andChannelOrderNoNotEqualTo(String value) {
            addCriterion("channel_order_no <>", value, "channelOrderNo");
            return (Criteria) this;
        }

        public Criteria andChannelOrderNoGreaterThan(String value) {
            addCriterion("channel_order_no >", value, "channelOrderNo");
            return (Criteria) this;
        }

        public Criteria andChannelOrderNoGreaterThanOrEqualTo(String value) {
            addCriterion("channel_order_no >=", value, "channelOrderNo");
            return (Criteria) this;
        }

        public Criteria andChannelOrderNoLessThan(String value) {
            addCriterion("channel_order_no <", value, "channelOrderNo");
            return (Criteria) this;
        }

        public Criteria andChannelOrderNoLessThanOrEqualTo(String value) {
            addCriterion("channel_order_no <=", value, "channelOrderNo");
            return (Criteria) this;
        }

        public Criteria andChannelOrderNoLike(String value) {
            addCriterion("channel_order_no like", value, "channelOrderNo");
            return (Criteria) this;
        }

        public Criteria andChannelOrderNoNotLike(String value) {
            addCriterion("channel_order_no not like", value, "channelOrderNo");
            return (Criteria) this;
        }

        public Criteria andChannelOrderNoIn(List<String> values) {
            addCriterion("channel_order_no in", values, "channelOrderNo");
            return (Criteria) this;
        }

        public Criteria andChannelOrderNoNotIn(List<String> values) {
            addCriterion("channel_order_no not in", values, "channelOrderNo");
            return (Criteria) this;
        }

        public Criteria andChannelOrderNoBetween(String value1, String value2) {
            addCriterion("channel_order_no between", value1, value2, "channelOrderNo");
            return (Criteria) this;
        }

        public Criteria andChannelOrderNoNotBetween(String value1, String value2) {
            addCriterion("channel_order_no not between", value1, value2, "channelOrderNo");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}